<html devsite>
  <head>
    <title>OTA Updates</title>
    <meta name="project_path" value="/_project.yaml" />
    <meta name="book_path" value="/_book.yaml" />
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->



    <p>
      Android devices in the field can receive and install over-the-air (OTA)
      updates to the system and application software. This section describes
      the structure of the update packages and the tools provided to build
      them. It is intended for developers who want to make the OTA update
      system work on new Android devices and those who are building update
      packages for use with released devices. OTA updates are designed to
      upgrade the underlying operating system and the read-only apps installed
      on the system partition; these updates do <em>not</em> affect
      applications installed by the user from Google Play.
    </p>

    <p>
      The Android Open Source Project (AOSP) includes a
      <a href="https://android.googlesource.com/platform/bootable/recovery/+/master/updater_sample/"
        class="external">SystemUpdaterSample</a> app that gives examples on
      how to use Android system update APIs to install OTA updates. The sample
      app is an example on how to use <code>update_engine</code> for A/B
      updates.
      For more information, see <a href="https://android.googlesource.com/platform/bootable/recovery/+/master/updater_sample/README.md"
        class="external"><code>updater_sample/README.md</code></a>.
    </p>

    <h2 id="ab_updates">A/B (seamless) system updates</h2>

      <p>
        Modern A/B devices have two copies of each partition, A and B. Devices
        apply the update to the currently unused partition while the system is
        running but idle. A/B devices do not need space to download the update
        package because they can apply the update as they read it from the
        network. This is called <em>streaming A/B</em>. A/B updates are also
        known as <em>seamless updates</em>. For more information about OTA
        updates for A/B devices, see
        <a href="/devices/tech/ota/ab/index.html">A/B (Seamless) System
          Updates
        </a>.
      </p>

    <h2 id="nonab_updates">Non-A/B system updates</h2>

      <p>
        Older devices have a special recovery partition containing the software
        needed to unpack a downloaded update package and apply the update to
        the other partitions. For more information, see
        <a href="/devices/tech/ota/nonab/index.html">Non-A/B System Updates
        </a>.
      </p>

  </body>
</html>
